<template>
  <div class="order-card-step">
    <div class="multi-nav-panel">
      <div class="nav-item active">Общее</div>
      <ObSelect
        v-model="selectVal"
        :items="dataSelect"
        @input="selected"
        class="nav-item"/>

      <div class="nav-tabs"
           :class="{active: className == selectVal}"
           v-for="(group, className) in testTabs"
           :key="className">
        <TabComponent v-for="(item, index) in group"
                      :key="index"
                      :data-source="item || {}"/>
      </div>

    </div>
    <div
      class="ob-order-contractor-card"
      @click="$emit('click')"
    >
      <div class="ob-order-contractor-card__caption">
        Маршрут по направлению {{ subOrders[0].startAddress }} → {{ subOrders[0].endAddress }}
      </div>
    </div>
    <MultiCard :value="routeItems" />
    <div class="mt40">
      <div class="ob-order-contractor-card__caption">
        События в целом по заказу
      </div>
      <div class="events-list">
        <div class="event">
          <div class="event-info">
            {{createdData}}
          </div>
          <div class="event-title">
            Создание заказа
          </div>
          <div class="event-owner">
            Заказчик
          </div>
        </div>
      </div>
    </div>
    <div class="add-event">
      <i class="icon plus"></i>
      <span>
        Добавить событие
      </span>
    </div>
    <ob-modal
      ref="selectExecutorManual"
      :title="'Исполнитель ' + (currentDoer && currentDoer.title)"
      okText="Выбрать исполнителя"
      size="small"
      is-show-controls
      data-qa="selectExecutorManualModal"
      @cancel="clearExecutor"
      @submit="setExecutor"
    >
      <p>
        Вы выбрали исполнителя вручную. Аукцион, который был автоматически
        назначен системой на ваш заказ, будет продолжен.
      </p>
    </ob-modal>
    <ob-modal
      ref="changeExecutor"
      title="Назначить ООО «СВАР»"
      okText="Выбрать исполнителя"
      size="small"
      is-show-controls
      data-qa="changeExecutorModal"
    >
      <p>
        У вас уже подтвержден букинг запрос с ООО «ТрансАстана». Вы уверены,
        что вы хотите заменить с ООО «ТрансАстана» на ООО «СВАР»?
        Подтверждение привет к отмене букинг запроса с ООО «ТрансАстана».
      </p>
    </ob-modal>
    <ob-modal
      ref="requestExecution"
      :title="'Отправка заявки на исполнение заказа за ' + (subOrder.executor && subOrder.executor.title)"
      size="medium"
      :is-show-controls="false"
      data-qa="requestExecutionModal"
    >
      <RequestExecutionModal
        :order-uuid="currentSubOrderUuid"
        @on-submited="onSignedHandler"
      />
    </ob-modal>
    <ob-modal
      ref="inputTariff"
      :title="'Укажите тариф для ' + (currentDoer && currentDoer.title)"
      okText="Далее"
      size="small"
      is-show-controls
      data-qa="inputTariffModal"
      @cancel="clearExecutor"
      @submit="setTariff"
    >
      <ObInput
        v-model="inputTariff"
        label="Тариф"
        placeholder="Введите значение"
        type="money:2"
      />
    </ob-modal>
  </div>
</template>

<script>
import cloneDeep from 'clone-deep'
import { mapGetters, mapActions, mapMutations } from 'vuex'
import MultiCard from './multiCard.vue'
import TabComponent from './TabComponent.vue'
import ObModal from 'common-components/src/obComponents/obModal'
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import RequestExecutionModal from '@/components/Order/modal/RequestExecutionModal'
import { formatNumber } from 'common-components/src/helpers/common'
import api from '@/api'

export default {
  name: 'multiOrderExecution',
  props: {
    uuid: {
      type: String,
      required: true
    }
  },
  components: {
    MultiCard,
    ObModal,
    ObInput,
    ObSelect,
    TabComponent,
    RequestExecutionModal
  },
  data() {
    return {
      selectVal: '0',
      dataSelect: [
        {code: 1, uuid: '0', title: 'москва → москва павелецкая'},
        {code: 2, uuid: '1', title: 'москва павелецкая → новосибирск'},
        {code: 3, uuid: '2', title: 'новосибирск → новосибирск'}
      ],
      currentDoer: null,
      inputTariff: '',
      route: {
        pointFrom: 'Москва',
        pointTo: 'Самара',
        items: [
          {
            uuid: 'log-003',
            type: 'location',
            done: false,
            current: false,
            point: 'from',
            status: 'ожидание начала рейса',
            pointName: 'ООО “ФМ Лоджистик Восток”',
            pointAddress: 'Россия, Московская область, г. Долгопрудный, ул. Новое шоссе, 34',
            date: '26.08.2019',
            time: '09:00 — 11:00'
          },
          {
            uuid: 'log-005',
            type: 'location',
            done: false,
            current: false,
            point: 'to',
            status: 'ожидание начала рейса',
            pointName: 'ООО “Нестле Фуд”',
            pointAddress: 'Россия, Самарская область, г. Кинель, ул. Промышленная, 13',
            date: '26.08.2019',
            time: '21:00 — 23:00'
          }
        ]
      },
      test: [
        {
          point: 'from',
          pointName : 'ООО “ФМ Лоджистик Вос...',
          pointAddress: 'Московская область, г. Долгопруд ный, ул. Новое шоссе, 34',
          topIcon: 'trailer',
          icon: 'pin'
        },
        {
          point: '',
          pointName : 'Москва Павелецкая',
          pointAddress: 'г. Москва, Павелецкая пл., 1',
          topIcon: 'van',
          icon: 'train'
        },
        {
          point: '',
          pointName : 'Челябинск-Главный',
          pointAddress: 'Привокзальная пл., 4, Челябинск, Челябинская обл., 454961',
          topIcon: 'trailer',
          icon: 'train'
        },
        {
          point: 'to',
          pointName : 'ООО “О России думаем”',
          pointAddress: 'Челябинская область, г. Челябинск, ул. Некрасова, д.142, стр. 2',
          icon: 'pin'
        }

      ],
      testTabs: [
        [
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            statusIcon: "LOAD",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            statusIcon: "CONTRACTED",
            statusNum: "к 324 бб  199",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            statusIcon: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            statusIcon: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            statusNum: "к 324 бб  199",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            statusIcon: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          }
        ],
        [
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "van"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "van"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "van"
          }
        ],
        [
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            statusNum: "к 324 бб  199",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "NEW",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "CONTRACTED",
            statusNum: "к 324 бб  199",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "BOOKED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          },
          {
            number: "PO20 929 9488",
            serviceCode: null,
            startAddress: "Москва",
            endAddress: "Москва",
            status: "ALLOCATED",
            contractorUuid: "d80eb503-a31e-467e-983e-3f92d74dfd8b",
            contractorTitle: "ООО «АВТОПАРК»",
            icon: "tractor"
          }
        ],
      ]
    }
  },
  computed: {
    ...mapGetters({
      order: 'order/order',
      subOrder: 'order/subOrder',
      subOrders: 'order/subOrders',
      selectedSubOrder: 'order/selectedSubOrder',
      isClient: 'order/isClient',
      isClicar: 'order/isClicar',
      isLoading: 'order/isLoading'
    }),
    orderId () {
      return this.$route.params.id
    },
    createdData () {
      let hours = new Date(this.order.createdAt).getHours()
      let minutes = new Date(this.order.createdAt).getMinutes()
      let day = new Date(this.order.createdAt).getDay()
      let month = new Date(this.order.createdAt).getMonth()
      let year = new Date(this.order.createdAt).getFullYear()
      return  hours + ':' + minutes + '\n' + day + '.' + month + '.' + year
    },
    isFirstOrder () {
      return this.uuid === this.orderId
    },
    routeItems () {
      //return this.subOrder.shipmentPoints
      return this.test
        ? {
          //items: this.subOrder.shipmentPoints.map((item, index) => {
          items: this.test.map((item, index) => {
            return {
              position:index,
              uuid: index,
              done: false,
              current: false,
              point: item.point,
              pointName: item.pointName,
              pointAddress: item.pointAddress,
              topIcon:item.topIcon,
              icon:item.icon
            }
          })
        }
        : {}
    },
    dropdownTabs () {
      if (this.isFirstOrder) return null
      let dropdownList = [
        {
          title: 'Изменить лимит',
          method: () => this.$refs.сhangeLimit.open()
        },
        {
          title: 'Отмена назначения исполнителя',
          method: () => this.$refs.CancelExecutor.open()
        },
        {
          title: 'Отмена назначения ресурса',
          method: () => this.$refs.CancelResurs.open()
        }
      ]

      if (this.subOrder.status === 'ALLOCATED') {
        dropdownList.push({
          title: 'Отправить заявку за исполнителя',
          method: () => this.$refs.requestExecution.open()
        })
      }

      return dropdownList
    },
    currentStatus () {
      return this.subOrder && this.subOrder.status
    },
    currentTariff () {
      if (this.subOrder.status !== 'NEW') {
        return this.subOrder.totalPrice
      } else {
        return ''
      }
    }
  },
  methods: {
    ...mapActions({
      selectExecutor: 'order/selectExecutor',
      getOrder: 'order/getOrder',
      getSubOrder: 'order/getSubOrder',
      getSubOrders: 'order/getSubOrders'
    }),
    ...mapMutations({
      setSubOrderData: 'order/setSubOrderData'
    }),
    selected () {
      console.log(this.selectVal)
    },
    formatNumber,
    clearExecutor () {
      this.currentDoer = null
      this.inputTariff = ''
      this.$refs.selectExecutorManual.close()
    },
    async setExecutor () {
      if (this.isLoading) {
        return false
      }
      try {
        this.selectExecutor({ uuid: this.selectedSubOrder.uuid, doer: this.currentDoer })
        this.getOrder({ uuid: this.orderId, timeout: 1000 })
        // this.updateSubOrders({ timeout: 1000 })
      } catch (e) {
        this.currentDoer = null
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалось выбрать исполнителя'
        })
      }
      this.$refs.selectExecutorManual.close()
    },
    onChangeExecutor (data) {
      this.currentDoer = data
      if (data) {
        setTimeout(() => {
          if (data.tripTariff) {
            this.$refs.selectExecutorManual.open()
          } else {
            this.$refs.inputTariff.open()
          }
        }, 300)
      }
    },
    setTariff () {
      this.currentDoer.tripTariff = this.inputTariff
      this.$refs.inputTariff.close()
      this.$refs.selectExecutorManual.open()
    },
    async onChangeResource(superclass, data) {
      if (this.isLoading) {
        return false
      }
      try {
        await api.orderProcess.selectResource({
          uuid: this.selectedSubOrder.uuid,
          data: { superclass, uuid: data.uuid }
        })
        this.setSuborderResource(data, superclass)
        this.updateSubOrders({ timeout: 1000 })
      } catch (e) {
        console.log(e)
      }
    },
    setSuborderResource (data, superclass) {
      let resources = this.subOrder && cloneDeep(this.subOrder.resources || [])
      resources = resources.filter((item) => {
        return item.superclass !== superclass && item.resourceSuperclass !== superclass
      })
      resources.push(data)
      this.setSubOrderData({ resources })
    },
    currentResource (type) {
      if (!this.subOrder || !this.subOrder.resources || !this.subOrder.resources.length) return null

      return this.subOrder.resources.find((item) => item.resourceSuperclass === type || item.superclass === type)
    },
    onSignedHandler () {
      this.$refs.requestExecution.close()
      this.updateSubOrders({ timeout: 1000 })
    },
    updateSubOrders({ timeout = 0 }) {
      this.getSubOrders({ timeout })
      this.getSubOrder({ uuid: this.selectedSubOrder.uuid, timeout })
    }
  }
}
</script>

<style lang="scss">
  @import "../../../../../node_modules/common-components/src/static/css/mixins";
  @import "../../../../../node_modules/common-components/src/static/css/variables";

  .ob-order-contractor-card {
    padding: 15px 15px;
    background-color: $background-white;

    .regular-text {
      @include font-mixin(12px, 16px, 400, $color-text-base, 0.4px);
    }
    & i {
      color: $cobalt;
    }
    &__caption {
      margin-bottom: 30px;
      @include font-mixin(20px, 28px, 600, $components-orderExecution_caption_font_color, 0.4px);
    }
    &__body {
      background-color: $light-lavender;
      padding: 20px;
      border: 1px solid $components-orderExecution_body_border;
      box-shadow: 0px 1px 7px rgba($color-blue-navy-blue, 0.1);
      border-radius: 4px;
      .row-inputs {
        margin-left: -0.5rem;
        margin-right: -0.5rem;
        & > [class^="col-"] {
          transition: maxWidth 0.2s;
          padding-left: 0.5rem;
          padding-right: 0.5rem;
        }
      }
    }
    &__title {
      display: flex;
      justify-content: space-between;
      align-items: center;
      height: 24px;
      margin-bottom: 19px;
      .col-item {
        display: flex;
        align-items: center;
        &:last-child {
          margin-left: 20px;
          flex-shrink: 0;
        }
      }
      &-icon {
        margin-right: 15px;
        max-width: 75px;
        font-size: 24px;
        color: $cobalt;
      }
      &-text {
        @include font-mixin(16px, 20px, 400, $color-text-base, 0.2px);
      }
      &-dropdown {
        .ob-menu-dropdown-container {
          margin-left: 8px;
          margin-right: -10px;
        }
      }
      &-limit {
        @include font-mixin(16px, 20px, 400);
        .icon {
          color: $color-blue-navy-blue;
          font-size: 12px;
          font-weight: bold;
        }
        & > span, & > i {
          margin-left: 4px;
        }
      }
    }
    &__searching {
      border: 1px solid $cornflower-craiola;
      box-sizing: border-box;
      border-radius: 3px;
      background: $lavender;
      opacity: 0.5;
      &__item {
        font-size: 16px;
        letter-spacing: 0.2px;
        color: $color-grey-span;
        margin: 20px 12px;
      }
    }

    &.--state-empty {
      padding: 16px 19px 19px;
    }
  }
</style>

<style lang="scss" scoped>
  @import "../../../../../node_modules/common-components/src/static/css/mixins";
  @import "../../../../../node_modules/common-components/src/static/css/variables";
  .mt20 {
    margin-top: 20px;
  }
  .mt40 {
    margin-top: 40px;
  }
  .mb20 {
    margin-bottom: 20px;
  }
  .mt10 {
    margin-top: 10px;
  }
  .mr10 {
    margin-right: 10px;
  }
  .fadeIn-enter, .fadeIn-leave-to {
    opacity: 0;
  }
  .fadeIn-enter-active, .fadeIn-leave-active {
    transition: all .2s ease-in-out;
  }
  .ob-selector__select{
    background: #000;
  }
  .multi-nav-panel {
    display: flex;
    margin-bottom: 40px;
    .nav-item{
      min-width: 77px;
      width: 77px;
      height: 52px;
      border-radius: 4px;
      display: flex;
      flex-direction: column;
      margin: 0 10px 10px 0;
      cursor: pointer;
      justify-content: center;
      background: $lavender  ;
      padding: 0 12px;
      @include font-mixin(12px, 20px, 400, $color-blue-navy-blue, 0.4px, uppercase);
      &.active{
        color: #fff;
        background: $color-blue-navy-blue;
      }
      &.ob-selector{
        min-width: 192px;
        padding: 0;
        ::v-deep .ob-selector__select {
          border: none;
          background: $lavender  ;
        }
        ::v-deep .ob-selector__title {
          justify-content: center;
        }
        ::v-deep .ob-selector__value {
          @include font-mixin(12px, 20px, 400, $color-blue-navy-blue, 0.4px, uppercase);
        }
        ::v-deep .ob-selector__value {
          white-space: normal;
        }
      }
    }
    .nav-tabs{
      display: none;
      flex-wrap: wrap;
      &.active{
        display: flex;
      }
    }
  }
  .events-list{
    padding: 20px;
    .event{
      padding: 6px 20px;
      background: $light-lavender ;
      display: flex;
      justify-content: space-between;
      align-items: center;
      &-info{
        white-space: pre-line;
        flex: 1;
        @include font-mixin(12px, 18px, 400, $color-grey-span, 0.4px, uppercase);
      }
      &-title{
        font-family: "Roboto", sans-serif;
        @include font-mixin(12px, 14px, 600, #000, 0.4px, uppercase);
        flex: 3;
      }
      &-owner{
        font-size: 12px;
        line-height: 14px;
        text-transform: uppercase;
        color: $color-grey-span ;
        font-weight: 600;
        flex: 1;
      }
    }
  }
  .add-event{
    display: flex;
    align-items: center;
    margin: 20px;
    .plus{
      color: $color-blue-navy-blue;
    }
    span{
      margin-left: 6px;
    }
  }
</style>
